| Home · All Classes · All Namespaces · Modules · Functions · Files

Public Slots | Signals | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
Tp::Client::ChannelTypeTubesInterface Class Reference
Client-side proxies » Channel proxies

`#include <TelepathyQt/Channel>`

Inheritance diagram for Tp::Client::ChannelTypeTubesInterface:
[legend]

## Public Slots

QDBusPendingReply< Tp::SupportedSocketMap > | GetAvailableStreamTubeTypes (int timeout=-1)
QDBusPendingReply< Tp::UIntList > | GetAvailableTubeTypes (int timeout=-1)
QDBusPendingReply< Tp::TubeInfoList > | ListTubes (int timeout=-1)
QDBusPendingReply< uint > | OfferDBusTube (const QString &service, const QVariantMap &parameters, int timeout=-1)
QDBusPendingReply< uint > | OfferStreamTube (const QString &service, const QVariantMap &parameters, uint addressType, const QDBusVariant &address, uint accessControl, const QDBusVariant &accessControlParam, int timeout=-1)
QDBusPendingReply< QString > | AcceptDBusTube (uint ID, int timeout=-1)
QDBusPendingReply< QDBusVariant > | AcceptStreamTube (uint ID, uint addressType, uint accessControl, const QDBusVariant &accessControlParam, int timeout=-1)
QDBusPendingReply | CloseTube (uint ID, int timeout=-1)
QDBusPendingReply< QString > | GetDBusTubeAddress (uint ID, int timeout=-1)
QDBusPendingReply< Tp::DBusTubeMemberList > | GetDBusNames (uint ID, int timeout=-1)
QDBusPendingReply< uint, QDBusVariant > | GetStreamTubeSocketAddress (uint ID, int timeout=-1)

## Signals

void | NewTube (uint ID, uint initiator, uint type, const QString &service, const QVariantMap &parameters, uint state)
void | TubeStateChanged (uint ID, uint state)
void | TubeClosed (uint ID)
void | DBusNamesChanged (uint ID, const Tp::DBusTubeMemberList &added, const Tp::UIntList &removed)
void | StreamTubeNewConnection (uint ID, uint handle)
Signals inherited from Tp::AbstractInterface
void | propertiesChanged (const QVariantMap &changedProperties, const QStringList &invalidatedProperties)

## Public Member Functions

| ChannelTypeTubesInterface (const QString &busName, const QString &objectPath, QObject *parent=0)
| ChannelTypeTubesInterface (const QDBusConnection &connection, const QString &busName, const QString &objectPath, QObject *parent=0)
| ChannelTypeTubesInterface (Tp::DBusProxy *proxy)
| ChannelTypeTubesInterface (const Tp::Client::ChannelInterface &mainInterface)
| ChannelTypeTubesInterface (const Tp::Client::ChannelInterface &mainInterface, QObject *parent)
Tp::PendingVariantMap * | requestAllProperties () const
Public Member Functions inherited from Tp::AbstractInterface
virtual | ~AbstractInterface ()
bool | isValid () const
QString | invalidationReason () const
QString | invalidationMessage () const
void | setMonitorProperties (bool monitorProperties)
bool | isMonitoringProperties () const
Public Member Functions inherited from QDBusAbstractInterface
virtual | ~QDBusAbstractInterface ()
bool | isValid () const
QDBusConnection | connection () const
QString | service () const
QString | path () const
QString | interface () const
QDBusError | lastError () const
void | setTimeout (int timeout)
int | timeout () const
QDBusMessage | call (const QString &method, const QVariant &arg1, const QVariant &arg2, const QVariant &arg3, const QVariant &arg4, const QVariant &arg5, const QVariant &arg6, const QVariant &arg7, const QVariant &arg8)
QDBusMessage | call (QDBus::CallMode mode, const QString &method, const QVariant &arg1, const QVariant &arg2, const QVariant &arg3, const QVariant &arg4, const QVariant &arg5, const QVariant &arg6, const QVariant &arg7, const QVariant &arg8)
QDBusMessage | callWithArgumentList (QDBus::CallMode mode, const QString &method, const QList< QVariant > &args)
bool | callWithCallback (const QString &method, const QList< QVariant > &args, QObject *receiver, const char *returnMethod, const char *errorMethod)
bool | callWithCallback (const QString &method, const QList< QVariant > &args, QObject *receiver, const char *slot)
QDBusPendingCall | asyncCall (const QString &method, const QVariant &arg1, const QVariant &arg2, const QVariant &arg3, const QVariant &arg4, const QVariant &arg5, const QVariant &arg6, const QVariant &arg7, const QVariant &arg8)
QDBusPendingCall | asyncCallWithArgumentList (const QString &method, const QList< QVariant > &args)
Public Member Functions inherited from QObject
| QObject (QObject *parent)
virtual | ~QObject ()
virtual bool | event (QEvent *e)
virtual bool | eventFilter (QObject *watched, QEvent *event)
virtual const QMetaObject * | metaObject () const
QString | objectName () const
void | setObjectName (const QString &name)
bool | isWidgetType () const
bool | signalsBlocked () const
bool | blockSignals (bool block)
QThread * | thread () const
void | moveToThread (QThread *targetThread)
int | startTimer (int interval)
void | killTimer (int id)
T | findChild (const QString &name) const
QList< T > | findChildren (const QString &name) const
QList< T > | findChildren (const QRegExp &regExp) const
QObject * | child (const char *objName, const char *inheritsClass, bool recursiveSearch) const
const QObjectList & | children () const
void | setParent (QObject *parent)
void | installEventFilter (QObject *filterObj)
void | removeEventFilter (QObject *obj)
bool | connect (const QObject *sender, const char *signal, const char *method, Qt::ConnectionType type) const
bool | disconnect (const char *signal, const QObject *receiver, const char *method)
bool | disconnect (const QObject *receiver, const char *method)
void | dumpObjectTree ()
void | dumpObjectInfo ()
bool | setProperty (const char *name, const QVariant &value)
QVariant | property (const char *name) const
QList< QByteArray > | dynamicPropertyNames () const
void | destroyed (QObject *obj)
QObject * | parent () const
bool | inherits (const char *className) const
void | deleteLater ()
| QObject (QObject *parent, const char *name)
void | insertChild (QObject *object)
void | removeChild (QObject *object)
bool | isA (const char *className) const
const char * | className () const
const char * | name () const
const char * | name (const char *defaultName) const
void | setName (const char *name)

## Static Public Member Functions

static QLatin1String | staticInterfaceName ()
Static Public Member Functions inherited from QObject
QString | tr (const char *sourceText, const char *disambiguation, int n)
QString | trUtf8 (const char *sourceText, const char *disambiguation, int n)
bool | connect (const QObject *sender, const char *signal, const QObject *receiver, const char *method, Qt::ConnectionType type)
bool | connect (const QObject *sender, const QMetaMethod &signal, const QObject *receiver, const QMetaMethod &method, Qt::ConnectionType type)
bool | disconnect (const QObject *sender, const char *signal, const QObject *receiver, const char *method)
bool | disconnect (const QObject *sender, const QMetaMethod &signal, const QObject *receiver, const QMetaMethod &method)

## Protected Member Functions

virtual void | invalidate (Tp::DBusProxy *, const QString &, const QString &)
Protected Member Functions inherited from Tp::AbstractInterface
| AbstractInterface (DBusProxy *proxy, const QLatin1String &interface)
| AbstractInterface (const QString &busName, const QString &path, const QLatin1String &interface, const QDBusConnection &connection, QObject *parent)
PendingVariant * | internalRequestProperty (const QString &name) const
PendingOperation * | internalSetProperty (const QString &name, const QVariant &newValue)
PendingVariantMap * | internalRequestAllProperties () const
Protected Member Functions inherited from QObject
QObject * | sender () const
int | senderSignalIndex () const
int | receivers (const char *signal) const
virtual void | timerEvent (QTimerEvent *event)
virtual void | childEvent (QChildEvent *event)
virtual void | customEvent (QEvent *event)
virtual void | connectNotify (const char *signal)
virtual void | disconnectNotify (const char *signal)
bool | checkConnectArgs (const char *signal, const QObject *object, const char *method)

## Additional Inherited Members

Protected Slots inherited from Tp::AbstractInterface
Static Protected Member Functions inherited from QObject
QByteArray | normalizeSignalSlot (const char *signalSlot)
Properties inherited from QObject
| objectName

## Detailed Description

Proxy class providing a 1:1 mapping of the D-Bus interface "org.freedesktop.Telepathy.Channel.Type.Tubes".

## Constructor & Destructor Documentation

## § ChannelTypeTubesInterface() [1/5]

Tp::Client::ChannelTypeTubesInterface::ChannelTypeTubesInterface | ( | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a ChannelTypeTubesInterface associated with the given object on the session bus.

Parameters

  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

## § ChannelTypeTubesInterface() [2/5]

Tp::Client::ChannelTypeTubesInterface::ChannelTypeTubesInterface | ( | const QDBusConnection & | connection,
|  | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a ChannelTypeTubesInterface associated with the given object on the given bus.

Parameters

  connection | The bus via which the object can be reached.
  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

## § ChannelTypeTubesInterface() [3/5]

Tp::Client::ChannelTypeTubesInterface::ChannelTypeTubesInterface | ( | Tp::DBusProxy * | proxy | ) |

Creates a ChannelTypeTubesInterface associated with the same object as the given proxy.

Parameters

  proxy | The proxy to use. It will also be the QObject::parent() for this object.

## § ChannelTypeTubesInterface() [4/5]

Tp::Client::ChannelTypeTubesInterface::ChannelTypeTubesInterface | ( | const Tp::Client::ChannelInterface & | mainInterface | ) |

explicit

Creates a ChannelTypeTubesInterface associated with the same object as the given proxy. Additionally, the created proxy will have the same parent as the given proxy.

Parameters

  mainInterface | The proxy to use.

## § ChannelTypeTubesInterface() [5/5]

Tp::Client::ChannelTypeTubesInterface::ChannelTypeTubesInterface | ( | const Tp::Client::ChannelInterface & | mainInterface,
|  | QObject * | parent
| ) |  |

Creates a ChannelTypeTubesInterface associated with the same object as the given proxy. However, a different parent object can be specified.

Parameters

  mainInterface | The proxy to use.
  parent | Passed to the parent class constructor.

## Member Function Documentation

## § staticInterfaceName()

static QLatin1String Tp::Client::ChannelTypeTubesInterface::staticInterfaceName | ( |  | ) |

inline static

Returns the name of the interface "org.freedesktop.Telepathy.Channel.Type.Tubes", which this class represents.

Returns
  The D-Bus interface name.

## § requestAllProperties()

Tp::PendingVariantMap* Tp::Client::ChannelTypeTubesInterface::requestAllProperties | ( |  | ) | const

inline

Request all of the DBus properties on the interface.

Returns
  A pending variant map which will emit finished when the properties have been retrieved.

## § GetAvailableStreamTubeTypes

QDBusPendingReply<Tp::SupportedSocketMap> Tp::Client::ChannelTypeTubesInterface::GetAvailableStreamTubeTypes | ( | int | timeout = `-1` | ) |

inline slot

Begins a call to the D-Bus method `GetAvailableStreamTubeTypes` on the remote object.

List the available address types and access-control types for stream tubes.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  timeout | The timeout in milliseconds.

Returns

A mapping from address types (members of Socket_Address_Type) to arrays of access-control type (members of Socket_Access_Control) that the connection manager supports for stream tubes with that address type. For simplicity, if a CM supports offering a particular type of tube, it is assumed to support accepting it.

A typical value for a host without IPv6 support:

          {
            Socket_Address_Type_IPv4:
              [Socket_Access_Control_Localhost, Socket_Access_Control_Port,
               Socket_Access_Control_Netmask],
            Socket_Address_Type_Unix:
              [Socket_Access_Control_Localhost, Socket_Access_Control_Credentials]
          }

If stream tubes are not supported, this will be an empty dictionary.

## § GetAvailableTubeTypes

QDBusPendingReply<Tp::UIntList> Tp::Client::ChannelTypeTubesInterface::GetAvailableTubeTypes | ( | int | timeout = `-1` | ) |

inline slot

Begins a call to the D-Bus method `GetAvailableTubeTypes` on the remote object.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  timeout | The timeout in milliseconds.

Returns

      An array of the available tube types, as defined by the Tube_Type
      enum.

## § ListTubes

QDBusPendingReply<Tp::TubeInfoList> Tp::Client::ChannelTypeTubesInterface::ListTubes | ( | int | timeout = `-1` | ) |

inline slot

Begins a call to the D-Bus method `ListTubes` on the remote object.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  timeout | The timeout in milliseconds.

Returns

      Return an array of tuples, each representing a tube, with the
      following members: the tube&apos;s ID the tube&apos;s initiator the
      tube&apos;s type the tube&apos;s service the tube&apos;s parameters
      the tube&apos;s state

## § OfferDBusTube

QDBusPendingReply<uint> Tp::Client::ChannelTypeTubesInterface::OfferDBusTube | ( | const QString & | service,
|  | const QVariantMap & | parameters,
|  | int | timeout = `-1`
| ) |  |

inline slot

Begins a call to the D-Bus method `OfferDBusTube` on the remote object.

Offers a D-Bus tube providing the service specified.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  service

      A string representing the service name that will be used over the
      tube. It should be a well-known D-Bus service name, of the form
      com.example.ServiceName.

  parameters

      A dictionary of properties for the new tube; the allowable keys,
      types and values are defined by the service. Connection managers
      must support the value being any primitive (non-container) D-Bus
      type, or a byte array &apos;ay&apos;.

  timeout | The timeout in milliseconds.

Returns

      The ID of the new tube.

## § OfferStreamTube

QDBusPendingReply<uint> Tp::Client::ChannelTypeTubesInterface::OfferStreamTube | ( | const QString & | service,
|  | const QVariantMap & | parameters,
|  | uint | addressType,
|  | const QDBusVariant & | address,
|  | uint | accessControl,
|  | const QDBusVariant & | accessControlParam,
|  | int | timeout = `-1`
| ) |  |

inline slot

Begins a call to the D-Bus method `OfferStreamTube` on the remote object.

Offer a stream tube exporting the local socket specified.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  service | A string representing the service name that will be used over the tube. It should be a well-known TCP service name as defined by http://www.iana.org/assignments/port-numbers or http://www.dns-sd.org/ServiceTypes.html, for instance "rsync" or "daap".
  parameters | A dictionary of properties for the new tube; the allowable keys, types and values are defined by the service. Connection managers must support the value being any primitive (non-container) D-Bus type, or a byte array 'ay'. These should usually be the same key-value pairs specified for use in the DNS-SD TXT record for that service.

  addressType

      The type of the listening address of the local service, as a member
      of Socket_Address_Type.

  address

      The listening address of the local service, as indicated by the
      address_type.

  accessControl

      The access control the local service applies to the local socket,
      specified so the connection manager can behave appropriately when
      it connects.

  accessControlParam

      A parameter for the access control type, to be interpreted as
      specified in the documentation for the Socket_Access_Control enum.

  timeout | The timeout in milliseconds.

Returns

      The ID of the new tube.

## § AcceptDBusTube

QDBusPendingReply<QString> Tp::Client::ChannelTypeTubesInterface::AcceptDBusTube | ( | uint | ID,
|  | int | timeout = `-1`
| ) |  |

inline slot

Begins a call to the D-Bus method `AcceptDBusTube` on the remote object.

Accept a D-Bus tube that's in the "local pending" state. The connection manager will attempt to open the tube. The tube remains in the "local pending" state until the TubeStateChanged signal is emitted.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  ID

      The ID of the tube to accept.

  timeout | The timeout in milliseconds.

Returns

      The string describing the address of the private bus. The client
      should not attempt to connect to the address until the tube is open.

## § AcceptStreamTube

QDBusPendingReply<QDBusVariant> Tp::Client::ChannelTypeTubesInterface::AcceptStreamTube | ( | uint | ID,
|  | uint | addressType,
|  | uint | accessControl,
|  | const QDBusVariant & | accessControlParam,
|  | int | timeout = `-1`
| ) |  |

inline slot

Begins a call to the D-Bus method `AcceptStreamTube` on the remote object.

Accept a stream tube that's in the "local pending" state. The connection manager will attempt to open the tube. The tube remains in the "local pending" state until the TubeStateChanged signal is emitted.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  ID

      The ID of the tube to accept.

  addressType

      The type of address the connection manager should listen on.

  accessControl

      The type of access control the connection manager should apply to
      the socket.

  accessControlParam

      A parameter for the access control type, to be interpreted as
      specified in the documentation for the Socket_Access_Control enum.

  timeout | The timeout in milliseconds.

Returns

      The address on which the connection manager will listen for
      connections to this tube. The client should not attempt to connect
      to the address until the tube is open.

## § CloseTube

QDBusPendingReply Tp::Client::ChannelTypeTubesInterface::CloseTube | ( | uint | ID,
|  | int | timeout = `-1`
| ) |  |

inline slot

Begins a call to the D-Bus method `CloseTube` on the remote object.

Close a tube.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  ID

      The ID of the tube to close.

  timeout | The timeout in milliseconds.

## § GetDBusTubeAddress

QDBusPendingReply<QString> Tp::Client::ChannelTypeTubesInterface::GetDBusTubeAddress | ( | uint | ID,
|  | int | timeout = `-1`
| ) |  |

inline slot

Begins a call to the D-Bus method `GetDBusTubeAddress` on the remote object.

For a D-Bus tube, return a string describing the address of the private bus.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  ID

      The ID of the tube to get an address for.

  timeout | The timeout in milliseconds.

Returns

      The bus address.

## § GetDBusNames

QDBusPendingReply<Tp::DBusTubeMemberList> Tp::Client::ChannelTypeTubesInterface::GetDBusNames | ( | uint | ID,
|  | int | timeout = `-1`
| ) |  |

inline slot

Begins a call to the D-Bus method `GetDBusNames` on the remote object.

For a multi-user (i.e. Handle_Type_Room) D-Bus tube, obtain a mapping between contact handles and their unique bus names on this tube.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  ID

      The ID of the tube to get names for.

  timeout | The timeout in milliseconds.

Returns

      An array of structures, each containing a contact handle and a
      D-Bus bus name.

## § GetStreamTubeSocketAddress

QDBusPendingReply<uint, QDBusVariant> Tp::Client::ChannelTypeTubesInterface::GetStreamTubeSocketAddress | ( | uint | ID,
|  | int | timeout = `-1`
| ) |  |

inline slot

Begins a call to the D-Bus method `GetStreamTubeSocketAddress` on the remote object.

For a stream tube, obtain the address of the socket used to communicate over this tube.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  ID

      The ID of the stream tube to get the socket for.

  timeout | The timeout in milliseconds.

Returns

      The type of the listening address of the socket, as a member of
      Socket_Address_Type.

      The listening address of the socket, as indicated by the
      address_type.

## § NewTube

void Tp::Client::ChannelTypeTubesInterface::NewTube | ( | uint | ID,
|  | uint | initiator,
|  | uint | type,
|  | const QString & | service,
|  | const QVariantMap & | parameters,
|  | uint | state
| ) |  |

signal

Represents the signal `NewTube` on the remote object.

Emitted when a tube is created.

Parameters

  ID

      The ID of the new tube.

  initiator

      The handle of the contact who initiated the tube.

  type

      The tube type, as defined by the Tube_Type enum.

  service

      A string representing the service that will be used over the tube.

  parameters

      The new tube&apos;s properties.

  state

      The new tube&apos;s state.

## § TubeStateChanged

void Tp::Client::ChannelTypeTubesInterface::TubeStateChanged | ( | uint | ID,
|  | uint | state
| ) |  |

signal

Represents the signal `TubeStateChanged` on the remote object.

Emitted when the state of a tube changes.

Parameters

  ID

      The ID of the tube that changed state.

  state

      The new state of the tube; see the Tube_State enumeration.

## § TubeClosed

void Tp::Client::ChannelTypeTubesInterface::TubeClosed | ( | uint | ID | ) |

signal

Represents the signal `TubeClosed` on the remote object.

Emitted when a tube has been closed. The ID of a closed tube is no longer valid. The ID may later be reused for a new tube.

Parameters

  ID

      The ID of the tube that was closed.

## § DBusNamesChanged

void Tp::Client::ChannelTypeTubesInterface::DBusNamesChanged | ( | uint | ID,
|  | const Tp::DBusTubeMemberList & | added,
|  | const Tp::UIntList & | removed
| ) |  |

signal

Represents the signal `DBusNamesChanged` on the remote object.

Emitted on a multi-user (i.e. Handle_Type_Room) D-Bus tube when a participant opens or closes the tube.

Parameters

  ID

      The ID of the tube whose names have changed.

  added

      Array of handles and D-Bus names of new participants.

  removed

      Array of handles of former participants.

## § StreamTubeNewConnection

void Tp::Client::ChannelTypeTubesInterface::StreamTubeNewConnection | ( | uint | ID,
|  | uint | handle
| ) |  |

signal

Represents the signal `StreamTubeNewConnection` on the remote object.

Emitted on a stream tube when a participant opens a new connection to its socket.

Parameters

  ID

      The ID of the tube

  handle

      The handle of the participant who opened the new connection

## § invalidate()

void Tp::Client::ChannelTypeTubesInterface::invalidate | ( | Tp::DBusProxy * | proxy,
|  | const QString & | error,
|  | const QString & | message
| ) |  |

protected virtual

Reimplemented from Tp::AbstractInterface.